#include <iostream>
#include <limits>

#define MAX_PACIJENTA 10000

struct Pacijent
{
	int o;
	int a;
	int b;
	int ab;
} pacijenti[MAX_PACIJENTA];

int o, a, b, ab;

void TakeO(int& left, int& taken)
{
	o -= left;
	taken = left;
	left = 0;
}
void TakeA(int& left, int& taken)
{
	if (left > a)
	{
		left -= a;
		taken = a;
		a = 0;
	}
	else
	{
		a -= left;
		taken = left;
		left = 0;
	}
}
void TakeB(int& left, int& taken)
{
	if (left > b)
	{
		left -= b;
		taken = b;
		b = 0;
	}
	else
	{
		b -= left;
		taken = left;
		left = 0;
	}
}
void TakeAB(int& left, int& taken)
{
	if (left > ab)
	{
		left -= ab;
		taken = ab;
		ab = 0;
	}
	else
	{
		ab -= left;
		taken = left;
		left = 0;
	}
}

int main()
{
	int n;
	std::cin >> n;	
	char str[3];

	std::cin >> o >> a >> b >> ab;	

	for (int i = 0; i < n; ++i)
	{
		std::cin >> str;
			
		if (str[0] == 'O')
			std::cin >> pacijenti[i].o;
		else if (str[0] == 'B')
			std::cin >> pacijenti[i].b;
		else if (str[0] == 'A' && str[1] == 'B')
			std::cin >> pacijenti[i].ab;
		else
			std::cin >> pacijenti[i].a;
	}	

	for (int i = 0; i < n; ++i)
		if (pacijenti[i].o != 0)
		{
			int left = pacijenti[i].o;
			TakeO(left, pacijenti[i].o);
		}		

	for (int i = 0; i < n; ++i)
	{
		if (pacijenti[i].a != 0)
		{
			int left = pacijenti[i].a;
			TakeA(left, pacijenti[i].a);

			if (left > 0)
				TakeO(left, pacijenti[i].o);
		}

		if (pacijenti[i].b != 0)
		{
			int left = pacijenti[i].b;
			TakeB(left, pacijenti[i].b);

			if (left > 0)
				TakeO(left, pacijenti[i].o);
		}
	}

	for (int i = 0; i < n; ++i)
	{
		if (pacijenti[i].ab != 0)
		{
			int left = pacijenti[i].ab;
			TakeAB(left, pacijenti[i].ab);

			if (left > 0)
			{
				TakeB(left, pacijenti[i].b);

				if (left > 0)
				{
					TakeA(left, pacijenti[i].a);

					if (left > 0)
						TakeO(left, pacijenti[i].o);
				}
			}
		}
	}

	if (o < 0)
	{
		printf("nemoguce\n");
		return 0;
	}

	printf("moguce\n");
	for (int i = 0; i < n; ++i)
	{
		printf("%d %d %d %d\n", pacijenti[i].o, pacijenti[i].a, pacijenti[i].b, pacijenti[i].ab);
	}

	return 0;
}